<?php

namespace Drupal\taxonomy_view_counter\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Database\Database;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;

/**
 * Handles updating the taxonomy term view count.
 */
class TaxonomyViewCounterController extends ControllerBase {

  /**
   * Updates the view count for a taxonomy term.
   */
  public function updateViewCount($tid, Request $request) {
    $database = Database::getConnection();

    $count = $database->select('taxonomy_view_counter', 't')
      ->fields('t', ['view_count'])
      ->condition('tid', $tid)
      ->execute()
      ->fetchField();

    if ($count !== FALSE) {
      // Update count.
      $database->update('taxonomy_view_counter')
        ->fields(['view_count' => $count + 1])
        ->condition('tid', $tid)
        ->execute();
    } else {
      // Insert new row.
      $database->insert('taxonomy_view_counter')
        ->fields(['tid' => $tid, 'view_count' => 1])
        ->execute();
    }

    return new JsonResponse(['status' => 'success', 'message' => 'View count updated', 'count' => $count]);
  }
}
