<?php

namespace Drupal\taxonomy_view_counter\Plugin\views\field;

use Drupal\views\Plugin\views\field\FieldPluginBase;
use Drupal\views\ResultRow;
use Drupal\Core\Database\Database;

/**
 * Provides a Views field for taxonomy page view count.
 *
 * @ViewsField("taxonomy_view_count")
 */
class TaxonomyViewCount extends FieldPluginBase {

  /**
   * {@inheritdoc}
   */
  public function render(ResultRow $values) {

    // Get the taxonomy term ID.
    $tid = $values->_entity->id();

    // Get the view count from the database.
    $view_count = Database::getConnection()->select('taxonomy_view_counter', 't')
      ->fields('t', ['view_count'])
      ->condition('tid', $tid)
      ->execute()
      ->fetchField();

    // Return 0 if no view count found.
    return $view_count ?: 0;
  }
}
